program tecfit;
uses dos,fitter;
const
        verbose     = true;
        trace       = false;
var
        m, n        : byte;
        nvpp        : byte;
        i, j,
        np          : integer;
        niter,
        maxiter     : longint;
        maxerr      : extended;
        result      : vector;
        data        : dataset;
        sfunc       : functype;
        t1,t2,t3,t4 : word;
        t           : extended;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}

{$I tecfunc}

{$I tecent}

procedure report;
  var   y,dy,s,ds     : extended;
        j,i           : byte;
  begin
  if verbose then
    begin
    writeln(' program exited after ',niter:5,' iterations');
    writeln;
    write(' #':3);
    for i := 1 to (nvpp - 1) do
      write('x':10,i:1);
    writeln('y':12,'y"':12,'dy':12);
    s := 0.0;
    for j := 1 to np do
      begin
      y := sfunc(result,data[j]);
      dy:= data[j,nvpp]- y;
      s := s + sqr(dy);
      write(j:4);
      for i := 1 to nvpp do
        write(data[j,i]:12,' ');
      writeln(y:12,' ',dy:12)
      end;
    writeln(' the mean is');
    end;
  for i := 1 to m+1 do
    begin
    writeln('par',i:3,' ',result[i]:14);
    end;
  if verbose then
    begin
    s := sqrt(s / np);
    writeln(' the standard deviation is ',s);
    ds := s / sqrt(np-m);
    writeln(' the estimated error is    ',ds);
    end;
  end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}

begin
sfunc:=func;
enter;

if verbose then
  begin
  writeln(' reading files ',paramstr(1),'.cst and ',paramstr(1),'.dat');
  writeln(m,' parameters');
  writeln(np,' data points');
  writeln(' maximum number iterations is ', maxiter:6);
  writeln(' maximum error is             ', maxerr:6);
  writeln(' data:');
  for i := 1 to np do
    begin
    for j := 1 to nvpp do write(data[i,j]:13);
    writeln;
    end;
  writeln(' starting guesses:');
  for i := 1 to m do
    begin
    writeln(i:4,' ',result[i]:12)
    end
  end;
gettime(t1,t2,t3,t4);
t := t4 / 100. + t3 + t2 * 60 + t1 * 3600;

simplex(sfunc,trace,nvpp,m,np,maxiter,maxerr,data,result,niter);

gettime(t1,t2,t3,t4);
t:=  t4 / 100. + t3 + t2 * 60 + t1 * 3600 - t;
if verbose then
  begin
  writeln(' after ',t:9:3,' seconds');
  end;
report;
end
 .
